﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
//using System.Linq;
using System.Text;
//using System.Threading.Tasks;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.Diagnostics;

namespace Drawing
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        //Ваша функция
        private bool function(double x, double y)
        {
            double z1 = Math.Abs(x) + Math.Abs(y);
            double z2 = x * x + y * y;
            return (z1 > 5) && (z1 < 10) != (z2 > 25) && (z2 < 100);
        }

//=====================================================================================

        private void button1_Click(object sender, EventArgs e)
        {
            //выбираем область в пикселях
            int w = pictureBox1.Width, h = pictureBox1.Height;  //Узнаём ширину и высоту в пикселях
            int nw = w / 2;
            int nh = h / 2;
            if (nw > nh) nw = nh;       //делаем её квадратной     
            int k = nw / 10;            //количество пикселей в 1.0
            if (k < 1) k = 1;
            int n = nw;
            double dx = 1.0 / k;
            double dy = dx;

            Graphics g = pictureBox1.CreateGraphics();          //Начинаем работу с pictureBox1
            g.Clear(Color.White);                               //Очищаем наш рисунок
            Pen myBlackPen = new Pen(Color.Black, 1);           //Создаём чёрную ручку шириной 1 пиксель   
            Pen myRedPen = new Pen(Color.Red, 3);               //Создаём красную ручку шириной 2 пикселя   
            
            SolidBrush myBlackBrash = new SolidBrush(Color.Black);

            System.Diagnostics.Stopwatch dt = new Stopwatch();
            dt.Reset();
            dt.Start();

            for (int x_ = -n; x_ <= n; x_++)
                for (int y_=-n; y_<= n; y_++)
                    if (function(x_*dx, y_*dy))
                        g.FillRectangle(myBlackBrash, x_ + n, y_ + n, 1, 1);

            dt.Stop();
            lbDuration1.Text = dt.ElapsedTicks.ToString();

            g.DrawLine(myRedPen, n, 0, n, n * 2);
            g.DrawLine(myRedPen, 0, n, n * 2, n);
            myRedPen.Width = 1;
            myRedPen.DashStyle = DashStyle.Dash;                //Теперь ручка пунктирная
            int li;
            for (int i = 0; i < 20; ++i)
            {
                li = 2 * n / 20 * i + 2;
                g.DrawLine(myRedPen, li, 0, li, n * 2);
                g.DrawLine(myRedPen, 0, li, n * 2, li);
            }
        }

//=====================================================================================

        private void Form1_Resize(object sender, EventArgs e)
        {
            Graphics g = pictureBox1.CreateGraphics();
            g.Clear(Color.White);
        }

//=====================================================================================

        private void bnPaint2_Click(object sender, EventArgs e)
        {
            //выбираем область в пикселях
            int w = pictureBox1.Width, h = pictureBox1.Height;  //Узнаём ширину и высоту в пикселях
            int nw = w / 2;
            int nh = h / 2;
            if (nw > nh) nw = nh;       //делаем её квадратной     
            int k = nw / 10;            //количество пикселей в 1.0
            if (k < 1) k = 1;
            int n = nw;
            double dx = 1.0 / k;
            double dy = dx;

            Graphics g = pictureBox1.CreateGraphics();          //Начинаем работу с pictureBox1
            g.Clear(Color.White);                               //Очищаем наш рисунок
            Pen myBlackPen = new Pen(Color.Black, 1);           //Создаём чёрную ручку шириной 1 пиксель   
            Pen myRedPen = new Pen(Color.Red, 3);               //Создаём красную ручку шириной 2 пикселя   
            
            SolidBrush myBlackBrash = new SolidBrush(Color.Black);

            System.Diagnostics.Stopwatch dt = new Stopwatch();
            dt.Reset();
            dt.Start();

            for (int x_ = -n; x_ <= n; x_++)
            {
                int ys = -n-1;
                while (++ys<=n)
                {
                        // search for start of a line
                    while (ys<=n && !function(x_*dx, ys*dy))
                        ys++;

                        // search for start of a line
                    int ye = ys + 1;
                    while (ye<=n && function(x_*dx, ye*dy))
                        ye++;

                        // now draw the line
                    g.FillRectangle(myBlackBrash, x_ + n, ys + n, 1, (ye - ys));

                    ys = ye + 1;
                }
            }

            dt.Stop();
            lbDuration2.Text = dt.ElapsedTicks.ToString();

            g.DrawLine(myRedPen, n, 0, n, n * 2);
            g.DrawLine(myRedPen, 0, n, n * 2, n);
            myRedPen.Width = 1;
            myRedPen.DashStyle = DashStyle.Dash;                //Теперь ручка пунктирная
            int li;
            for (int i = 0; i < 20; ++i)
            {
                li = 2 * n / 20 * i + 2;
                g.DrawLine(myRedPen, li, 0, li, n * 2);
                g.DrawLine(myRedPen, 0, li, n * 2, li);
            }
        }

//=====================================================================================

        private void bnPaint3_Click(object sender, EventArgs e)
        {
            //выбираем область в пикселях
            int w = pictureBox1.Width, h = pictureBox1.Height;  //Узнаём ширину и высоту в пикселях
            int nw = w / 2;
            int nh = h / 2;
            if (nw > nh) nw = nh;       //делаем её квадратной     
            int k = nw / 10;            //количество пикселей в 1.0
            if (k < 1) k = 1;
            int n = nw;
            double dx = 1.0 / k;
            double dy = dx;

            Graphics g = pictureBox1.CreateGraphics();          //Начинаем работу с pictureBox1
            g.Clear(Color.White);                               //Очищаем наш рисунок
            Pen myBlackPen = new Pen(Color.Black, 1);           //Создаём чёрную ручку шириной 1 пиксель   
            Pen myRedPen = new Pen(Color.Red, 3);               //Создаём красную ручку шириной 2 пикселя   

            SolidBrush myBlackBrash = new SolidBrush(Color.Black);

            System.Diagnostics.Stopwatch dt = new Stopwatch();
            dt.Reset();
            dt.Start();

            int xs, xe;
            for (int y_= -n; y_<=n; y_++)
            {
                xs = -n - 1;
                while (++xs <= n)
                {
                    // search for start of a line
                    while (xs<=n && !function(xs*dx, y_*dy))
                        xs++;

                    // search for start of a line
                    xe = xs + 1;
                    while (xe<=n && function(xe*dx, y_*dy))
                        xe++;

                    // now draw the line
                    g.FillRectangle(myBlackBrash, xs+n, y_+n, (xe-xs), 1);

                    xs = xe + 1;
                }
            }

            dt.Stop();
            lbDuration3.Text = dt.ElapsedTicks.ToString();

            g.DrawLine(myRedPen, n, 0, n, n * 2);
            g.DrawLine(myRedPen, 0, n, n * 2, n);
            myRedPen.Width = 1;
            myRedPen.DashStyle = DashStyle.Dash;                //Теперь ручка пунктирная
            int li;
            for (int i = 0; i < 20; ++i)
            {
                li = 2 * n / 20 * i + 2;
                g.DrawLine(myRedPen, li, 0, li, n * 2);
                g.DrawLine(myRedPen, 0, li, n * 2, li);
            }
        }

//=====================================================================================

        private void bnPaint4_Click(object sender, EventArgs e)
        {
            //выбираем область в пикселях
            int w = pictureBox1.Width, h = pictureBox1.Height;  //Узнаём ширину и высоту в пикселях
            int nw = w / 2;
            int nh = h / 2;
            if (nw > nh) nw = nh;       //делаем её квадратной     
            int k = nw / 10;            //количество пикселей в 1.0
            if (k < 1) k = 1;
            int n = nw;
            double dx = 1.0 / k;
            double dy = dx;

            Graphics g = pictureBox1.CreateGraphics();          //Начинаем работу с pictureBox1
            g.Clear(Color.White);                               //Очищаем наш рисунок
            Pen myBlackPen = new Pen(Color.Black, 1);           //Создаём чёрную ручку шириной 1 пиксель   
            Pen myRedPen = new Pen(Color.Red, 3);               //Создаём красную ручку шириной 2 пикселя   

            SolidBrush myBlackBrash = new SolidBrush(Color.Black);

            System.Diagnostics.Stopwatch dt = new Stopwatch();
            dt.Reset();
            dt.Start();

            for (int y_ = -n; y_ <= n; y_++)
            {
                for (int x_=-n; x_<=n; x_++)
                {
                    if (function(x_*dx, y_*dy))
                    {
                        g.FillRectangle(myBlackBrash, x_+n, y_+n, 1, 1);
                    }
                }
            }

            dt.Stop();
            lbDuration4.Text = dt.ElapsedTicks.ToString();

            g.DrawLine(myRedPen, n, 0, n, n * 2);
            g.DrawLine(myRedPen, 0, n, n * 2, n);
            myRedPen.Width = 1;
            myRedPen.DashStyle = DashStyle.Dash;                //Теперь ручка пунктирная
            int li;
            for (int i = 0; i < 20; ++i)
            {
                li = 2 * n / 20 * i + 2;
                g.DrawLine(myRedPen, li, 0, li, n * 2);
                g.DrawLine(myRedPen, 0, li, n * 2, li);
            }
        }

//=====================================================================================

        private void bnPaint5_Click(object sender, EventArgs e)
        {
            //выбираем область в пикселях
            int w = pictureBox1.Width, h = pictureBox1.Height;  //Узнаём ширину и высоту в пикселях
            int nw = w / 2;
            int nh = h / 2;
            if (nw > nh) nw = nh;       //делаем её квадратной     
            int k = nw / 10;            //количество пикселей в 1.0
            if (k < 1) k = 1;
            int n = nw;
            double dx = 1.0 / k;
            double dy = dx;

            Graphics g = pictureBox1.CreateGraphics();          //Начинаем работу с pictureBox1
            g.Clear(Color.White);                               //Очищаем наш рисунок
            Pen myBlackPen = new Pen(Color.Black, 1);           //Создаём чёрную ручку шириной 1 пиксель   
            Pen myRedPen = new Pen(Color.Red, 3);               //Создаём красную ручку шириной 2 пикселя   

            SolidBrush myBlackBrash = new SolidBrush(Color.Black);

            System.Diagnostics.Stopwatch dt = new Stopwatch();
            dt.Reset();
            dt.Start();

            int xs; //, xe;
            bool fprev, fthis;
            for (int y_ = -n; y_ <= n; y_++)
            {
                xs = n+1; 
                //xe=-n-1;
                fprev = false;
                for (int x_ = -n; x_ <= n; x_++)
                {
                    fthis = function(x_*dx, y_*dy);
                    if (fprev!=fthis)
                    {
                        if (fthis)
                            xs = x_;
                        else
                        {
                            g.FillRectangle(myBlackBrash, xs+n, y_+n, (x_-xs), 1);
                        }
                    }
                    fprev = fthis;
                }
            }

            dt.Stop();
            lbDuration5.Text = dt.ElapsedTicks.ToString();

            g.DrawLine(myRedPen, n, 0, n, n * 2);
            g.DrawLine(myRedPen, 0, n, n * 2, n);
            myRedPen.Width = 1;
            myRedPen.DashStyle = DashStyle.Dash;                //Теперь ручка пунктирная
            int li;
            for (int i = 0; i < 20; ++i)
            {
                li = 2 * n / 20 * i + 2;
                g.DrawLine(myRedPen, li, 0, li, n * 2);
                g.DrawLine(myRedPen, 0, li, n * 2, li);
            }
        }

//=====================================================================================
//=====================================================================================
//=====================================================================================
//=====================================================================================
//=====================================================================================

    }
}
